import usb._objfinalizer as _objfinalizer
from _typeshed import Incomplete
from typing import Iterable, Optional

class _DescriptorInfo(str): ...

class _ResourceManager:
    backend: Incomplete
    dev: Incomplete
    handle: Incomplete
    lock: Incomplete
    def __init__(self, dev, backend) -> None: ...
    def managed_open(self): ...
    def managed_close(self) -> None: ...
    index: Incomplete
    bConfigurationValue: int
    def managed_set_configuration(self, device, config) -> None: ...
    def managed_claim_interface(self, device, intf) -> None: ...
    def managed_release_interface(self, device, intf) -> None: ...
    def managed_set_interface(self, device, intf, alt) -> None: ...
    def setup_request(self, device, endpoint): ...
    def get_interface_and_endpoint(self, device, endpoint_address): ...
    def get_active_configuration(self, device): ...
    def release_all_interfaces(self, device) -> None: ...
    def dispose(self, device, close_handle: bool = ...) -> None: ...

class USBError(IOError):
    backend_error_code: Incomplete
    def __init__(
        self,
        strerror,
        error_code: Incomplete | None = ...,
        errno: Incomplete | None = ...,
    ) -> None: ...

class USBTimeoutError(USBError): ...
class NoBackendError(ValueError): ...

class Endpoint:
    device: Incomplete
    index: Incomplete
    def __init__(
        self,
        device,
        endpoint,
        interface: int = ...,
        alternate_setting: int = ...,
        configuration: int = ...,
    ) -> None: ...
    def write(self, data, timeout: Incomplete | None = ...): ...
    def read(self, size_or_buffer, timeout: Incomplete | None = ...): ...
    def clear_halt(self) -> None: ...

class Interface:
    device: Incomplete
    alternate_index: Incomplete
    index: Incomplete
    configuration: Incomplete
    def __init__(
        self,
        device,
        interface: int = ...,
        alternate_setting: int = ...,
        configuration: int = ...,
    ) -> None: ...
    def endpoints(self): ...
    def set_altsetting(self) -> None: ...
    def __iter__(self): ...
    def __getitem__(self, index): ...

class Configuration:
    device: Incomplete
    index: Incomplete
    def __init__(self, device, configuration: int = ...) -> None: ...
    def interfaces(self): ...
    def set(self) -> None: ...
    def __iter__(self): ...
    def __getitem__(self, index): ...

class Device(_objfinalizer.AutoFinalizedObject):
    bus: Incomplete
    address: Incomplete
    port_number: int
    speed: Incomplete
    default_timeout: Incomplete

    def __eq__(self, other): ...
    def __hash__(self): ...
    def configurations(self): ...
    def __init__(self, dev, backend) -> None: ...
    @property
    def langids(self): ...
    @property
    def serial_number(self) -> str: ...
    @property
    def product(self): ...
    @property
    def parent(self) -> Optional[Device]: ...
    @property
    def manufacturer(self): ...
    @property
    def backend(self): ...
    @property
    def idVendor(self) -> int: ...
    @property
    def idProduct(self) -> int: ...
    def set_configuration(self, configuration: Incomplete | None = ...) -> None: ...
    def get_active_configuration(self): ...
    def set_interface_altsetting(
        self,
        interface: Incomplete | None = ...,
        alternate_setting: Incomplete | None = ...,
    ) -> None: ...
    def clear_halt(self, ep) -> None: ...
    def reset(self) -> None: ...
    def write(self, endpoint, data, timeout: Incomplete | None = ...): ...
    def read(self, endpoint, size_or_buffer, timeout: Incomplete | None = ...): ...
    def ctrl_transfer(
        self,
        bmRequestType,
        bRequest,
        wValue: int = ...,
        wIndex: int = ...,
        data_or_wLength: Incomplete | None = ...,
        timeout: Incomplete | None = ...,
    ): ...
    def is_kernel_driver_active(self, interface): ...
    def detach_kernel_driver(self, interface) -> None: ...
    def attach_kernel_driver(self, interface) -> None: ...
    def __iter__(self): ...
    def __getitem__(self, index): ...

def find(
    find_all: bool = ...,
    backend: Incomplete | None = ...,
    custom_match: Incomplete | None = ...,
    **args
) -> Iterable[Device]: ...
def show_devices(verbose: bool = ..., **kwargs): ...
